﻿Imports System.Runtime.InteropServices
Imports Microsoft.Win32

Public Class Form1

    Private appWin As IntPtr
    Private msgWin As IntPtr
    Private chatWin As IntPtr
    Private equipWin As IntPtr
    Private invWin As IntPtr
    Private lagWin As IntPtr
    Private charWin As IntPtr
    Private graphWin As IntPtr
    Private webWin As IntPtr
    Private browserWin As IntPtr

    Shared WM_CLOSE As UInteger = &H10
    Private p As Process
    Private pm As Process
    Private pg As Process
    Private pe As Process
    Private pi As Process
    Private pl As Process
    Private pc As Process
    Private px As Process
    Private pb As Process

    Private MainRect As New Rect()
    Private MessageRect As New Rect()
    Private chatRect As New Rect()
    Private equipRect As New Rect()
    Private invRect As New Rect()
    Private lagRect As New Rect()
    Private graphRect As New Rect()
    Private charRect As New Rect()

    Private allowDrag As Boolean

    Private monsters As Dictionary(Of String, String)

    Public Structure Rect
        Public Property Left() As Integer
            Get
                Return m_Left
            End Get
            Set
                m_Left = Value
            End Set
        End Property
        Private m_Left As Integer
        Public Property Top() As Integer
            Get
                Return m_Top
            End Get
            Set
                m_Top = Value
            End Set
        End Property
        Private m_Top As Integer
        Public Property Right() As Integer
            Get
                Return m_Right
            End Get
            Set
                m_Right = Value
            End Set
        End Property
        Private m_Right As Integer
        Public Property Bottom() As Integer
            Get
                Return m_Bottom
            End Get
            Set
                m_Bottom = Value
            End Set
        End Property
        Private m_Bottom As Integer
    End Structure

    <DllImport("user32.dll")>
    Private Shared Function PostMessage(hWnd As IntPtr, Msg As UInteger, wParam As Integer, lParam As Integer) As Boolean
    End Function
    <DllImport("user32.dll")>
    Private Shared Function SetParent(hWndChild As IntPtr, hWndNewParent As IntPtr) As IntPtr
    End Function
    <DllImport("user32.dll")>
    Private Shared Function SetWindowLong(hWnd As IntPtr, nIndex As Integer, dwNewLong As Integer) As Integer
    End Function
    <DllImport("user32.dll")>
    Private Shared Function MoveWindow(Handle As IntPtr, x As Integer, y As Integer, w As Integer, h As Integer, repaint As Boolean) As Boolean
    End Function
    <DllImport("user32.dll")>
    Public Shared Function GetWindowRect(hwnd As IntPtr, ByRef rectangle As Rect) As Boolean
    End Function
    <DllImport("user32.dll")>
    Public Shared Function SetForegroundWindow(hWnd As IntPtr) As Boolean
    End Function
    <DllImport("user32.dll", EntryPoint:="FindWindow")>
    Public Shared Function FindWindow(sClass As String, sWindow As String) As Integer
    End Function
    <DllImport("user32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Shared Function GetForegroundWindow() As IntPtr
    End Function

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load

        SplitContainer1.Width = Width
        SplitContainer1.Height = Height
        TabControl1.Top = 0
        TabControl2.Top = 0
        TabControl1.Left = 0
        TabControl2.Left = 0

        For Each p As Process In Process.GetProcessesByName("TomeNET")
            p.Kill()
        Next
        LoadMonsters()
        Randomize()
        Top = 0
        Me.Left = 0
        WebBrowser1.Top = 0
        WebBrowser1.Left = 0
        WebBrowser1.Height = Height - 250
        WebBrowser1.Width = Width - 250
        WebBrowser1.ObjectForScripting = True
        WebBrowser1.ScriptErrorsSuppressed = True
        p = Process.Start("Tomenet.exe")
        p.WaitForInputIdle()
        appWin = p.MainWindowHandle
        p.WaitForInputIdle()
        SetParent(appWin, Panel1.Handle)
        SetWindowLong(appWin, -16, &H10000000)
back:
        p.WaitForInputIdle()
        For Each p1 As Process In Process.GetProcessesByName("TomeNET")
            If p1.MainWindowTitle = "Game messages" Then
                p1.WaitForInputIdle()
                msgWin = p1.MainWindowHandle
                SetParent(msgWin, Panel2.Handle)
                SetWindowLong(msgWin, -16, &H10000000)
                pm = p1
                GoTo back
            ElseIf p1.MainWindowTitle = "Chat" Then
                p1.WaitForInputIdle()
                chatWin = p1.MainWindowHandle
                SetParent(chatWin, Panel3.Handle)
                SetWindowLong(chatWin, -16, &H10000000)
                pg = p1
                GoTo back
            ElseIf p1.MainWindowTitle = "Equipment" Then
                p1.WaitForInputIdle()
                equipWin = p1.MainWindowHandle
                p1.WaitForInputIdle()
                SetParent(equipWin, Panel4.Handle)
                SetWindowLong(equipWin, -16, &H10000000)
                GetWindowRect(equipWin, MessageRect)
                Panel4.Height = 50000
                GoTo back
            ElseIf p1.MainWindowTitle = "Inventory" Then
                p1.WaitForInputIdle()
                invWin = p1.MainWindowHandle
                p1.WaitForInputIdle()
                SetParent(invWin, Panel5.Handle)
                SetWindowLong(invWin, -16, &H10000000)
                GetWindowRect(invWin, MessageRect)
                Panel5.Height = 50000
                GoTo back
            ElseIf p1.MainWindowTitle = "Term-7" Then
                p1.WaitForInputIdle()
                lagWin = p1.MainWindowHandle
                p1.WaitForInputIdle()
                SetParent(lagWin, Panel7.Handle)
                SetWindowLong(lagWin, -16, &H10000000)
                GetWindowRect(lagWin, MessageRect)
                Panel7.Height = 50000
                GoTo back
            ElseIf p1.MainWindowTitle = "Term-6" Then
                p1.WaitForInputIdle()
                graphWin = p1.MainWindowHandle
                p1.WaitForInputIdle()
                SetParent(graphWin, Panel6.Handle)
                SetWindowLong(graphWin, -16, &H10000000)
                GetWindowRect(graphWin, MessageRect)
                Panel6.Height = 50000
                GoTo back
            ElseIf p1.MainWindowTitle = "Character overview" Then
                p1.WaitForInputIdle()
                charWin = p1.MainWindowHandle
                p1.WaitForInputIdle()
                SetParent(charWin, Panel8.Handle)
                SetWindowLong(charWin, -16, &H10000000)
                GetWindowRect(charWin, MessageRect)
                Panel8.Height = 50000
                GoTo back
            ElseIf p1.MainWindowTitle <> "" Then
                p1.CloseMainWindow()
                GoTo back
            End If
        Next

        MessageRect = New Rect()
        GetWindowRect(msgWin, MessageRect)
        Panel2.Top = -(MessageRect.Bottom - MessageRect.Top) + TabControl2.Top - (TabControl1.Height - 150)
        Panel2.Height = 50000
        MainRect = New Rect()
        GetWindowRect(chatWin, chatRect)
        Panel3.Top = -(chatRect.Bottom - chatRect.Top) + TabControl2.Top - (TabControl1.Height - 150)
        Panel3.Height = 50000

        Panel1.BringToFront()

        MoveWindow(appWin, 0, 0, Width, Height, True)
        MoveWindow(msgWin, 0, 0, Width, Height, True)
        MoveWindow(equipWin, 0, 0, Width, Height, True)
        MoveWindow(invWin, 0, 0, Width, Height, True)
        MoveWindow(lagWin, 0, 0, Width, Height, True)
        MoveWindow(charWin, 0, 0, Width, Height, True)
        MoveWindow(graphWin, 0, 0, Width, Height, True)
        MoveWindow(webWin, 0, 0, Width, Height, True)

        Panel1.Width = 50000
        Panel2.Width = 50000
        Panel3.Height = 50000
        Panel3.Width = 50000
        Panel4.Height = 50000
        Panel4.Width = 50000
        Panel5.Height = 50000
        Panel5.Width = 50000
        Panel6.Height = 50000
        Panel6.Width = 50000
        Panel7.Height = 50000
        Panel7.Width = 50000
        Panel8.Height = 50000
        Panel8.Width = 50000
        Panel9.Height = 50000
        Panel9.Width = 50000
        BackColor = Color.Black
        WebBrowser2.Height = Height - TabControl1.Bottom
        WebBrowser2.Width = Width

        VScrollBar1.AllowDrop = True
        VScrollBar1.Maximum = 40
        VScrollBar1.Minimum = 0
        VScrollBar1.Value = 30
        VScrollBar1.Left = Screen.PrimaryScreen.WorkingArea.Width - VScrollBar1.Width
        SetForegroundWindow(appWin)
        Me.SplitContainer1.Panel1.Controls.Add(Me.VScrollBar1)

        Try

            Dim myKey As RegistryKey = Registry.CurrentUser.OpenSubKey("Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION\", True)
            myKey.SetValue(Process.GetCurrentProcess().ProcessName + ".exe", 11)
            myKey.Close()

        Catch ex As Exception

        End Try

    End Sub


    Public Sub FormClose() Handles Me.FormClosing

        For Each p1 As Process In Process.GetProcessesByName("TomeNET")
            p1.Kill()
        Next

    End Sub

    Private Sub Scrolling() Handles VScrollBar1.Scroll, TabControl1.SelectedIndexChanged, Me.Activated, SplitContainer1.SplitterMoved

        VScrollBar1.Height = SplitContainer1.Panel1.Height
        VScrollBar1.Top = SplitContainer1.Panel1.Top
        TabControl1.Height = SplitContainer1.Panel1.Height

        GetWindowRect(msgWin, MessageRect)
        Panel2.Top = 0
        Dim top As Long
        top = (30 - VScrollBar1.Value) * (SplitContainer1.Panel1.Height / 30) - (MessageRect.Bottom - MessageRect.Top) + SplitContainer1.Panel1.Height - 50
        MoveWindow(msgWin, 0, top, Width, Height, True)
        Panel2.Height = 50000
        top = (30 - VScrollBar1.Value) * (SplitContainer1.Panel1.Height / 30) - (chatRect.Bottom - chatRect.Top) + SplitContainer1.Panel1.Height - 50
        GetWindowRect(chatWin, chatRect)
        Panel3.Top = 0
        MoveWindow(chatWin, 0, top, Width, Height, True)
        Panel3.Height = 50000

    End Sub

    Private Sub RefocusTomenet() Handles TabControl2.SelectedIndexChanged,
                                         TabControl1.SelectedIndexChanged,
                                         TabControl1.MouseDown,
                                         TabControl2.MouseDown,
                                         Panel1.MouseDown,
                                         SplitContainer1.MouseUp,
                                         VScrollBar1.MouseUp,
                                         SplitContainer1.Panel1.MouseDown,
                                         SplitContainer1.Panel2.MouseDown
        SetForegroundWindow(appWin)
    End Sub

    Private Sub Timer1_Tick() Handles Timer1.Tick

        If TabControl2.SelectedTab.Text = "Webpage" Or
           TabControl2.SelectedTab.Text = "Gallery" Then
            Exit Sub
        End If

        MoveWindow(appWin, 0, 0, Width, Height, True)
        MoveWindow(equipWin, 0, 0, Width, Height, True)
        MoveWindow(invWin, 0, 0, Width, Height, True)
        MoveWindow(lagWin, 0, 0, Width, Height, True)
        MoveWindow(charWin, 0, 0, Width, Height, True)
        MoveWindow(graphWin, 0, 0, Width, Height, True)

        If p.HasExited() Then Close()

    End Sub

    Private Sub LoadMonsters()

        Dim counter As Integer = 0
        Dim line As String
        Dim words() As String

        ' Read the file and display it line by line.
        Dim file As New System.IO.StreamReader("lib\game\r_info.txt")
        line = file.ReadLine()
        monsters = New Dictionary(Of String, String)

        While (line IsNot Nothing)
            words = line.Split(":")
            If words.GetUpperBound(0) > 1 Then
                If words(0) = "N" Then
                    Console.WriteLine(words(2))
                    If (Not monsters.ContainsKey(words(2))) Then
                        monsters.Add(counter, words(2))
                        counter = counter + 1
                    End If
                End If
            End If
            line = file.ReadLine()
        End While

        file.Close()

    End Sub

    Private Sub Button1_Click()
        If WebBrowser1.IsBusy() Then Exit Sub
        WebBrowser1.Navigate("www.tomenet.eu")
    End Sub

    Private Sub Button2_Click()
        If WebBrowser2.IsBusy() Then
            Panel9.Enabled = False
            Exit Sub
        End If
        Dim mymonsterNum As Single = Rnd()
        Dim mymonster As String = monsters(CInt(mymonsterNum * monsters.Count()))
        mymonster = mymonster.Replace(" ", "+")
        WebBrowser2.Navigate("https://privatelee.com/images/?q=" + mymonster)
        Panel9.Enabled = True
    End Sub

End Class
